// -*- C++ -*-
/*!
 * @file  MatchingComponent.cpp
 * @brief Template Matching Component
 * $Date$
 *
 * $Id$
 */

#include "MatchingComponent.h"
#include "Camera.h"


IplImage* src =NULL;// = cvCreateImage( cvSize(320,240),IPL_DEPTH_8U, 1);
IplImage* osrc=NULL;// = cvCreateImage( cvGetSize(src),IPL_DEPTH_8U, 3);//3);//NULL;
IplImage* odst =NULL;// cvCreateImage( cvGetSize(src), 8, 1 );
IplImage* dst =NULL;// cvCreateImage( cvGetSize(src), 8, 1 );
IplImage* cdst =NULL;// cvCreateImage( cvGetSize(src), 8, 3 );


// Module specification
// <rtc-template block="module_spec">
static const char* matchingcomponent_spec[] =
  {
    "implementation_id", "MatchingComponent",
    "type_name",         "MatchingComponent",
    "description",       "Template Matching Component",
    "version",           "0.1",
    "vendor",            "OsakaUniv",
    "category",          "Generic",
    "activity_type",     "DataFlowComponent",
    "max_instance",      "",
    "language",          "C++",
    "lang_type",         "compile",
    // Configuration variables
    "conf.default.int_width", "320",
    "conf.default.int_height", "240",

    ""
  };
// </rtc-template>

MatchingComponent::MatchingComponent(RTC::Manager* manager)
  : RTC::DataFlowComponentBase(manager),
    // <rtc-template block="initializer">
    m_InImageDataIn("InImageData", m_InImageData),
    m_OutImageDataOut("OutImageData", m_OutImageData),
    
    // </rtc-template>
	dummy(0)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  registerInPort("InImageData", m_InImageDataIn);
  
  // Set OutPort buffer
  registerOutPort("OutImageData", m_OutImageDataOut);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

}

MatchingComponent::~MatchingComponent()
{
}


RTC::ReturnCode_t MatchingComponent::onInitialize()
{
  // <rtc-template block="bind_config">
  // Bind variables and configuration variable
  bindParameter("int_width", m_int_width, "320");
  bindParameter("int_height", m_int_height, "240");
  
  // </rtc-template>
  return RTC::RTC_OK;
}



/*
RTC::ReturnCode_t MatchingComponent::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MatchingComponent::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MatchingComponent::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t MatchingComponent::onActivated(RTC::UniqueId ec_id)
{
  int i;

  src = cvCreateImage( cvSize(m_int_width,m_int_height),IPL_DEPTH_8U, 1);
  osrc = cvCreateImage( cvGetSize(src),IPL_DEPTH_8U, 3);//3);//NULL;

  odst = cvCreateImage( cvSize(m_int_width,m_int_height),IPL_DEPTH_8U, 1);
  cdst = cvLoadImage("temp.bmp",0);
  printf("%d %d \n",cdst->width,cdst->height);
  dst= cvCreateImage( cvSize(m_int_width+1-cdst->width,m_int_height-cdst->height+1),IPL_DEPTH_32F, 1);
  //cdst = cvCreateImage( cvGetSize(src),IPL_DEPTH_8U, 3);//3);//NULL;

  //cvCvtColor(cdst,odst,CV_BGR2GRAY);

  printf("test1 \n");

  /*inport part begin*/
  m_InImageDataIn.read();
  /*
  if(m_InImageData.data.length()>0){
    memcpy(osrc->imageData,(void *)&(m_InImageData.data[0]),m_int_width*m_int_height*3);//m_InImageData.data.length());
  }  
  */
  for(i=0;i<m_InImageData.data.length();i++){
    osrc->imageData[i]=m_InImageData.data[i];
  }

  /*inport part end*/


  return RTC::RTC_OK;
}



RTC::ReturnCode_t MatchingComponent::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}



RTC::ReturnCode_t MatchingComponent::onExecute(RTC::UniqueId ec_id)
{
  int i,si;
  /*inport part begin*/
  m_InImageDataIn.read();
  /*
  if(m_InImageData.data.length()>0){
    memcpy(osrc->imageData,(void *)&(m_InImageData.data[0]),m_int_width*m_int_height*3);//m_InImageData.data.length());
  }
  */

  //si=m_InImageData.data.length();
  //printf("%d \n",si);
  if(m_InImageData.data.length()==(m_int_width)*(m_int_height)*3){
    printf("suc \n");
    for(i=0;i<m_InImageData.data.length();i++){
      osrc->imageData[i]=m_InImageData.data[i];
    }

    /*inport part end*/
    
    cvCvtColor(osrc,src,CV_BGR2GRAY);

    //printf("test2 \n");
    //if(m_InImageData.data.length()>0){
      cvMatchTemplate(src,cdst,dst,CV_TM_CCOEFF_NORMED);
      //printf("test3 \n");
      //}

    double minVal=0,maxVal=0;
    CvPoint minLoc,maxLoc,opposite;
    cvMinMaxLoc(dst,&minVal,&maxVal,&minLoc,&maxLoc,NULL);
    //printf("Position %d %d \n", maxLoc.x,maxLoc.y);
    
    opposite.x=maxLoc.x+cdst->width;
    opposite.y=maxLoc.y+cdst->height;
    cvRectangle(osrc,maxLoc,opposite,CV_RGB(0,0,255),3,8,0);
    
  }

  /*outport part begin*/
  m_OutImageData.data.length(osrc->imageSize);
  memcpy((void *)&(m_OutImageData.data[0]),osrc->imageData,m_int_width*m_int_height*3);//m_InImageData.data.length());
  m_OutImageDataOut.write();
  /*outport part end*/

  cvWaitKey(100);

  return RTC::RTC_OK;
}


/*
RTC::ReturnCode_t MatchingComponent::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MatchingComponent::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MatchingComponent::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MatchingComponent::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MatchingComponent::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void MatchingComponentInit(RTC::Manager* manager)
  {
    RTC::Properties profile(matchingcomponent_spec);
    manager->registerFactory(profile,
                             RTC::Create<MatchingComponent>,
                             RTC::Delete<MatchingComponent>);
  }
  
};


